#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "imageInput.h"

#define BUFFER_SIZE 100
#define FILE_HEADER_STRING "__info2_image_file_format__"

// TODO Implementieren Sie geeignete Hilfsfunktionen für das Lesen der Bildserie aus einer Datei
static FILE* openFileCheckHeader(const char *path)
{
    FILE *fp = NULL;

    fp = fopen(path, "rb");
    if(fp == NULL)
        return NULL;
    char headerbuffer[BUFFER_SIZE];
    size_t headerlength = strlen(FILE_HEADER_STRING);
    if((fread(headerbuffer, sizeof(char), headerlength, fp)) < headerbuffer)
    {
        fclose(fp);
        return NULL;
    }
    if(strncmp(FILE_HEADER_STRING, headerbuffer, headerlength) != 0)
    {
        flcose(fp);
        return NULL;
    }
    return fp;
}//Oeffnet die Datei. 2. liest aus Datei headerlaenge laenge aus speichert in array vergleicht mit gewolltem header.
///Gibt bei Erfolg (header laenge richtig, richtiger header) den FILE* Zeiger zurück welcher nun gespeichert hat
///dass nun der header Teil gelesen wurde und somit die nächste Funktion ab dieser Stelle weiter liest. 
///NULL, wenn falscher header.
// TODO Vervollständigen Sie die Funktion readImages unter Benutzung Ihrer Hilfsfunktionen
static int readWidthHeightCount(FILE *fp, unsigned int *count, unsigned int *width, unsigned int *height)
{
    unsigned short count_s;
    unsigned short width_s;
    unsigned short height_s;
    if(fread(&count_s, sizeof(unsigned short), 1, fp) != 1)
    {
        return -1;
    }
    if(fread(&width_s, sizeof(unsigned short), 1, fp) != 1)
    {
        return -1;
    }
    if(fread(&height_s, sizeof(unsigned short), 1, fp) != 1)
    {
        return -1;
    }
    *count = (unsigned int)count_s;
    *width = (unsigned int)width_s;
    *height = (unsigned int)height_s;
    return 0;
}
/*
readWidthHeightCount: liest die drei shorts ein, welche Hoehe, Breite und Anzahl sind. (SHORT!!)
*/
GrayScaleImageSeries *readImages(const char *path)
{
    GrayScaleImageSeries *series = NULL;
    
    return series;
}

// TODO Vervollständigen Sie die Funktion clearSeries, welche eine Bildserie vollständig aus dem Speicher freigibt
void clearSeries(GrayScaleImageSeries *series)
{
}